﻿namespace UltraSpreadSheetMemoryStrean
{
    using System;
    using System.IO;
    using System.Windows.Forms;
    using Infragistics.Documents.Excel;

    public partial class Form1 : Form
    {
        private bool mbUseExcel97 = false;

        public Form1()
        {
            this.InitializeComponent();
            this.Load += Form1_Load;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
                if (mbUseExcel97)
                {
                    SpreadSheet.Workbook.SetCurrentFormat(WorkbookFormat.Excel97To2003);
                    SpreadSheet.Workbook = Infragistics.Documents.Excel.Workbook.Load(@".\test2.xls");
                }
                else
                {
                    SpreadSheet.Workbook.SetCurrentFormat(WorkbookFormat.Excel2007);
                    SpreadSheet.Workbook = Infragistics.Documents.Excel.Workbook.Load(@".\test.xlsx");
                }

                MemoryStream saveStream = new MemoryStream();
                SpreadSheet.Workbook.Save(saveStream);

                byte[] bytFile = new byte[0];
                bytFile = (byte[])saveStream.ToArray();

                SpreadSheet.Workbook = null;

                // load
                Workbook wb;
                if (mbUseExcel97)
                    wb = new Workbook(WorkbookFormat.Excel97To2003);
                else
                    wb = new Workbook(WorkbookFormat.Excel2007);

                MemoryStream loadStream = new MemoryStream();
                loadStream.Write(bytFile, 0, bytFile.Length - 1);
                wb = Infragistics.Documents.Excel.Workbook.Load(loadStream);
                SpreadSheet.Workbook = wb;
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
    }
}
